#ifndef _COMHOOKS_
#define _COMHOOKS_

//-------------------------------
 typedef struct _METHOD_HOOK {
  LONG    MethodNo;   //can be ALL_METHODS
  LPCVOID NewMethod;  //pointer to new routine
 } METHOD_HOOK, *LPMETHOD_HOOK;

typedef const METHOD_HOOK *LPCMETHOD_HOOK;

 #define  ALL_METHODS -1
 #define  NUM_METHODS_UNKNOWN -1
 #define  NUM_PARAMETERS_UNKNOWN -1
//-------------------------------
typedef const GUID *LPCGUID;

// dwFlags:
 #define  CONST_INTERFACE 1
 #define  CLASS_INTERFACE 2
 #define  COM_HOOKS_END   -1

// CLSIDs, xCLSIDs:
typedef const CLSID *LPCCLSID;
 #define  NO_CLASSES      (LPCLSID*)0
 #define  ALL_CLASSES     (LPCLSID*)-1
 #define  TERM_CLSID      (LPCLSID)-1


// IIDs, xIIDs:
typedef const IID *LPCIID;
 #define  NO_INTERFACES   (LPCIID*)0
 #define  ALL_INTERFACES  (LPCIID*)-1
 #define  TERM_IID        (LPCIID)-1

 typedef struct _COM_HOOK {
  DWORD              dwFlags;
  LPCVOID             CLSIDs;
  const LPCCLSID*    xCLSIDs;
  const LPCIID*         IIDs;
  const LPCIID*        xIIDs;
  DWORD           NumMethods;
  LPCMETHOD_HOOK MethodHooks;
  LPCVOID         lpUserData;
 } COM_HOOK, *LPCOM_HOOK;

typedef const COM_HOOK *LPCCOM_HOOK;

//-------------------------------
 typedef LONG (WINAPI *TGetVersion)(VOID);
 typedef ULONGLONG (WINAPI *TCallOldMethod)(LPVOID, DWORD);
 typedef VOID  (WINAPI *THookMethods)(LPCCLSID, LPCIID, LPVOID*, LPCOM_HOOK, DWORD);
 typedef LONG  (WINAPI *TGetNumMethods)(LPCIID, LPVOID);
 typedef LPCVOID (WINAPI *TGetMethodAddr)(LPCVOID);
 typedef BOOL (WINAPI *TCompareIDs)(LPCGUID, LPCGUID);

 typedef struct _COM_HOOK_APIS {
  TGetVersion GetVersion;
  TCallOldMethod CallOldMethod;
  THookMethods HookMethods;
  TGetNumMethods GetNumMethods;
  TGetMethodAddr GetMethodAddr;
  TCompareIDs CompareIDs;
 //can be extended with newer versions, hence check CH version for APIs available
 } COM_HOOK_APIS, *LPCOM_HOOK_APIS;

typedef const COM_HOOK_APIS *LPCCOM_HOOK_APIS;

//for HookMethods last parameter
#define ALL_COM_HOOKS 0

//-------------------------------
#define _CHSign 0x486D6F43  

 typedef struct _CHINFO {
   DWORD           Reserved02[02];
   DWORD           CHSign;
   LPCOM_HOOK_APIS CHApis;
   LPCVOID         OldMethod;
   LPCOM_HOOK      ComHookChain;
   LPCOM_HOOK      lpComHook;
   LPVOID          mThis;
   LPCVOID         mlpVtbl;
   CLSID           mCLSID;
   IID             mIID;
   DWORD           MethodNo;
 } CHINFO, *LPCHINFO;

 typedef struct _ACHINFO {
   DWORD           Reserved10[10];
   CHINFO          CHInfo;
 } ACHINFO, *LPACHINFO;
//------------------------------------------------------------------
 #define TERM_METHOD_HOOK {0,NULL}
 #define UNKNOWN_GUID     {-1,-1,-1,{-1,-1,-1,-1,-1,-1,-1,-1}}
 #define TERM_COM_HOOK    {COM_HOOKS_END}

#ifdef CH_STATIC_LINKING
  #ifdef _MSC_VER
    #pragma comment(lib, "SComHooks")
    #pragma comment(lib, "KERNEL32")
    #pragma comment(lib, "USER32")
    #pragma comment(lib, "ADVAPI32")
    #pragma comment(lib, "OLE32")
    #pragma comment(lib, "SHELL32")
    #ifdef __cplusplus
      extern "C" {
    #endif
      DWORD WINAPI RegisterComHookChain(LPCCOM_HOOK ComHookChain);
    #ifdef __cplusplus
      }
    #endif
  #else
    #ifdef __TURBOC__
      #pragma comment(lib, "SbComHooks.lib")
      #ifdef __cplusplus
        extern "C" {
      #endif
        DWORD WINAPI _RegisterComHookChain(LPCCOM_HOOK ComHookChain);
      #ifdef __cplusplus
        }
      #endif
      #define RegisterComHookChain _RegisterComHookChain
    #else
      //#define CHServerName   TEXT("ComHooks.dll")
      #define CHRegisterName "RegisterComHookChain"
      typedef LONG (WINAPI *TCHRegister)(LPCCOM_HOOK);
      #define __UNKNOWNC__
      #undef CH_STATIC_LINKING
    #endif
  #endif
#else
  #define CHServerName   TEXT("ComHooks.dll")
  #define CHRegisterName "RegisterComHookChain"
  typedef LONG (WINAPI *TCHRegister)(LPCCOM_HOOK);
#endif

#endif //#ifndef _COMHOOKS_