IFNDEF _COMHOOKS_
_COMHOOKS_ EQU 1
;-------------------------------
  ALL_METHODS    EQU   -1

  NUM_METHODS_UNKNOWN EQU -1
  NUM_PARAMETERS_UNKNOWN EQU -1

IFDEF ??version  ;TASM32
  METHOD_HOOK    STRUCT
   methodNo      DWORD ? ;can be ALL_METHODS
   NewMethod     DWORD ?
  METHOD_HOOK    ENDS
ELSE
  METHOD_HOOK    STRUCT
   MethodNo      DWORD ? ;can be ALL_METHODS
   NewMethod     DWORD ?
  METHOD_HOOK    ENDS
ENDIF

;-------------------------------
;dwFlags:
  CONST_INTERFACE = 1
  CLASS_INTERFACE = 2
  COM_HOOKS_END   = -1

;rclsids, xrclsids:
  NO_CLASSES     EQU 0
  ALL_CLASSES    EQU -1
  TERM_CLSID     EQU -1

;riids, xriids:
  NO_INTERFACES  EQU 0
  ALL_INTERFACES EQU -1
  TERM_IID       EQU -1


IFDEF ??version ;TASM32

 GUID STRUC
  Data1 DD ?
  Data2 DW ?
  Data3 DW ?
  Data4 LABEL BYTE
  STRUC
        DB ?
        DB ?
        DB ?
        DB ?
        DB ?
        DB ?
        DB ?
        DB ?
  ENDS
 GUID ENDS
 CLSID EQU <GUID>
 IID   EQU <GUID>

 COM_HOOK        STRUCT
  dWFlags        DWORD ? ;if = COMHOOK_ENDS ..last struct
  CLSIDs         DWORD ? ;classes to hook
                         ;if (dwFlags & CLASS_INTERFACE)
                         ; then ALL_INTERFACES or pointer to array of pointers to CLSIDs terminated by TERM_CLSID
                         ;if (dwFlags & CONST_INTERFACE)
                         ; then pointer to function returning pointer to an object
  xCLSIDs        DWORD ? ;classes to exclude
                         ;ALL_CLASSES or pointer to arrary of pointers of CLSIDs terminated by TERM_CLSID
  IIDs           DWORD ? ;interfaces to hook
                         ;ALL_INTERFACES or pointer to array of pointers of IIDs terminated by TERM_IID
  xIIDs          DWORD ? ;interfaces to exclude
                         ;ALL_INTERFACES or pointer to array of pointers of IIDs terminated by TERM_IID
  NumMethods     DWORD ? ;number of methods interface or NUM_METHODS_UNKNOWN
  MethodHooks    DWORD ? ;pointer to array of METHOD_HOOK structure terminated by TERM_METHOD_HOOK
  lpUserData     DWORD ? ;available for user
 COM_HOOK        ENDS
ELSE
 COM_HOOK        STRUCT
  dwFlags        DWORD ? ;if = COMHOOK_ENDS ..last struct
  CLSIDs         DWORD ? ;classes to hook
                         ;if (dwFlags & CLASS_INTERFACE)
                         ; then ALL_INTERFACES or pointer to array of pointers to CLSIDs terminated by TERM_CLSID
                         ;if (dwFlags & CONST_INTERFACE)
                         ; then pointer to function returning pointer to an object
  xCLSIDs        DWORD ? ;classes to exclude
                         ;ALL_CLASSES or pointer to arrary of pointers of CLSIDs terminated by TERM_CLSID
  IIDs           DWORD ? ;interfaces to hook
                         ;ALL_INTERFACES or pointer to array of pointers of IIDs terminated by TERM_IID
  xIIDs          DWORD ? ;interfaces to exclude
                         ;ALL_INTERFACES or pointer to array of pointers of IIDs terminated by TERM_IID
  NumMethods     DWORD ? ;number of methods interface or NUM_METHODS_UNKNOWN
  MethodHooks    DWORD ? ;pointer to array of METHOD_HOOK structure terminated by TERM_METHOD_HOOK
  lpUserData     DWORD ? ;available for user
 COM_HOOK        ENDS
ENDIF ;TASM32

  ALL_COM_HOOKS  = 0
;-------------------------------
IFNDEF ??version
  IFNDEF _APIMACRO_
     _TGetVersion    TYPEDEF PROTO
     _TCallOldMethod TYPEDEF PROTO :DWORD, :DWORD
     _THookMethods   TYPEDEF PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
     _TGetNumMethods TYPEDEF PROTO :DWORD, :DWORD
     _TGetMethodAddr TYPEDEF PROTO :DWORD
     _TCompareIDs    TYPEDEF PROTO :DWORD, :DWORD

     TGetVersion    TYPEDEF PTR _TGetVersion
     TCallOldMethod TYPEDEF PTR _TCallOldMethod
     THookMethods   TYPEDEF PTR _THookMethods
     TGetNumMethods TYPEDEF PTR _TGetNumMethods
     TGetMethodAddr TYPEDEF PTR _TGetMethodAddr
     TCompareIDs    TYPEDEF PTR _TCompareIDs

    COM_HOOK_APIS   STRUCT
     GetVersion     TGetVersion    ?
     CallOldMethod  TCallOldMethod ?
     HookMethods    THookMethods   ?
     GetNumMethods  TGetNumMethods ?
     GetMethodAddr  TGetMethodAddr ?
     CompareIDs     TCompareIDs    ?
     ;can be extended with newer versions, hence check CH version for APIs available
    COM_HOOK_APIS   ENDS
  ENDIF
ENDIF
IFNDEF COM_HOOK_APIS 
  COM_HOOK_APIS   STRUCT
   GetVersion     DWORD ?
   CallOldMethod  DWORD ?
   HookMethods    DWORD ?
   GetNumMethods  DWORD ?
   GetMethodAddr  DWORD ?
   CompareIDs     DWORD ?
   ;can be extended with newer versions, hence check CH version for APIs available
  COM_HOOK_APIS   ENDS
ENDIF
;-------------------------------
  _CHSign        ="ComH"

  CHINFO         STRUCT
   Reserved02    DWORD 02 DUP (?)
   CHSign        DWORD _CHSign
   CHApis        DWORD ?
   OldMethod     DWORD ?
   ComHookChain  DWORD ?
   lpComHook     DWORD ?
   mThis         DWORD ?
   mlpVtbl       DWORD ?
   mCLSID        CLSID <> 
   mIID          IID   <> 
   MethodNo      DWORD ? 
  CHINFO  ENDS

  ACHINFO        STRUCT
   Reserved10    DWORD 10 DUP (?)
   CHInfo        CHINFO <>
  ACHINFO        ENDS
;------------------------------------------------------------------
  TERM_METHOD_HOOK EQU  <0,0>
  TERM_COM_HOOK EQU  <DWORD COM_HOOKS_END>
  UNKNOWN_GUID   EQU  <-1,-1,-1,<-1,-1,-1,-1,-1,-1,-1,-1>>

  BeginComHooks  MACRO __CHCname
    ALIGN 4
    __CHCname    LABEL COM_HOOK
                 ENDM
  EndComHooks    EQU  TERM_COM_HOOK

IFDEF CH_STATIC_LINKING
  IFDEF _APIMACRO_
    INCLUDELIB iKERNEL32
    INCLUDELIB iUSER32
    INCLUDELIB iADVAPI32
    INCLUDELIB iOLE32
    IFDEF ??version
      INCLUDELIB iSHELL32
    ELSE
      INCLUDELIB iSHELL32 /EXPORT:GetApiHookChain=_GetApiHookChain
    ENDIF
    INCLUDELIB SiComHooks
  ELSE
    IFDEF ??version ;TASM32
      INCLUDELIB SbComHooks.lib
      _RegisterComHookChain PROTO :DWORD
      RegisterComHookChain EQU _RegisterComHookChain
    ELSE
      INCLUDELIB KERNEL32
      INCLUDELIB USER32
      INCLUDELIB ADVAPI32
      INCLUDELIB OLE32
      INCLUDELIB SHELL32
      INCLUDELIB SComHooks /EXPORT:GetApiHookChain=_GetApiHookChain@0
      RegisterComHookChain PROTO :DWORD
    ENDIF
  ENDIF
ELSE
  CHRegisterName EQU DB "RegisterComHookChain",0
  IF UNICODE
    CHServerName EQU WORD 'C','o','m','H','o','o','k','s','.','d','l','l',0
  ELSE
    CHServerName EQU DB "ComHooks.dll",0
  ENDIF
ENDIF

IFNDEF ??version
  IFNDEF _APIMACRO_
    _TCHRegister  TYPEDEF PROTO :DWORD
     TCHRegister  TYPEDEF PTR _TCHRegister
  ENDIF
ENDIF   

ENDIF