unit ComHooks;

{$ALIGN ON}
{$MINENUMSIZE 4}

interface
uses Windows, ActiveX;

const

 ALL_METHODS = -1;
 NUM_METHODS_UNKNOWN = -1;
 NUM_PARAMETERS_UNKNOWN = -1;

 CONST_INTERFACE  = 1;
 CLASS_INTERFACE  = 2;
 COM_HOOKS_END    = -1;

 NO_CLASSES       = Pointer(0);
 ALL_CLASSES      = Pointer(-1);
 TERM_CLSID       = Pointer(-1);

 NO_INTERFACES    = Pointer(0);
 ALL_INTERFACES   = Pointer(-1);
 TERM_IID         = Pointer(-1);

 ALL_COM_HOOKS    = 0;

 _CHSign          = $486D6F43;
//////////////////////////////////////////////////

type
//-------------------------------
 lpdw = ^DWORD;

 METHOD_HOOK =
   record  
     MethodNo  : Integer;
     NewMethod : Pointer;
   end;

 AMETHOD_HOOK   = array of METHOD_HOOK;
 LPMETHOD_HOOK  = ^AMETHOD_HOOK;
 LPCMETHOD_HOOK = ^AMETHOD_HOOK;
//-------------------------------

//  LPGUID   = ^TGUID;
//  LPCGUID  = ^TGUID;
//  LPCLSID  = ^TCLSID;
//  LPCCLSID = ^TCLSID;
//  LPIID    = ^TIID;
//  LPCIID   = ^TIID;

GUID =
  record
  Data1: LongWord;
  Data2: Word;
  Data3: Word;
  Data4: array[0..7] of Byte;
end;

  CLSID    = GUID;
  IID      = GUID;

  LPGUID   = ^GUID;
  LPCGUID  = ^GUID;
  LPCLSID  = ^CLSID;
  LPCCLSID = ^CLSID;
  LPIID    = ^IID;
  LPCIID   = ^IID;
//-------------------------------

 COM_HOOK =
   record
     dwFlags     : Integer;
     CLSIDs      : Pointer;
     xCLSIDs     : LPCLSID;
     IIDs        : LPIID;
     xIIDs       : LPIID;
     NumMethods  : Integer;
     MethodHooks : LPCMETHOD_HOOK;
     lpUserData  : Pointer;
   end;

 LPCOM_HOOK  = ^COM_HOOK;
 LPCCOM_HOOK = ^COM_HOOK;
 ACOM_HOOK   = array of COM_HOOK;
 LPCOM_HOOK_CHAIN  = ^ACOM_HOOK;
 LPCCOM_HOOK_CHAIN = ^ACOM_HOOK;
//-------------------------------

 TGetVersion    = function() : Integer; stdcall;
 TCallOldMethod = function(lpThis : Pointer; NumParameters : Integer) : LongLong; stdcall;
 THookMethods   = procedure(rclsid : LPCCLSID; riid : LPCIID; pv : Pointer; ComHookChain : LPCOM_HOOK; NumHooks : Integer); stdcall;
 TGetNumMethods = function(riid : LPCIID; pv : Pointer) : LongWord; stdcall;
 TGetMethodAddr = function(lpMethod : Pointer): Pointer; stdcall;
 TCompareIDs    = function(guid1 : LPCGUID; guid2 : LPCGUID) : Boolean; stdcall;

 COM_HOOK_APIS =
   record
     GetVersion    : TGetVersion;
     CallOldMethod : TCallOldMethod;
     HookMethods   : THookMethods;
     GetNumMethods : TGetNumMethods;
     GetMethodAddr : TGetMethodAddr;
     CompareIDs    : TCompareIDs;
 //can be extended with newer versions, therefore check CH version for APIs available
   end; 

 LPCOM_HOOK_APIS  = ^COM_HOOK_APIS;
 LPCCOM_HOOK_APIS = ^COM_HOOK_APIS;

//-------------------------------

 CHINFO =
   record
     Reserved02   : array[0..1] of LongWord;
     CHSign       : LongWord;
     CHApis       : LPCCOM_HOOK_APIS;
     OldMethod    : Pointer;
     ComHookChain : LPCOM_HOOK;
     lpComHook    : LPCOM_HOOK;
     mThis        : Pointer;
     mlpVtbl      : Pointer;
     mCLSID       : LPCLSID;
     mIID         : LPIID;
     MethodNo     : Integer;
   end;

 LPCHINFO  = ^CHINFO;
 LPCCHINFO = ^CHINFO;

 ACHINFO =
   record
     Reserved10   : array[0..9] of LongWord;
    CHInfo        : CHINFO;
   end;

 LPACHINFO  = ^ACHINFO;
 LPCACHINFO = ^ACHINFO;
//-------------------------------

const
// TERM_METHOD_HOOK : METHOD_HOOK = (MethodNo :0; NewMethod : nil);
// UNKNOWN_GUID     : GUID = (Data1:$FFFFFFFF; Data2:$FFFF; Data3:$FFFF; Data4:($FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF));
// TERM_COM_HOOK    : COM_HOOK = (dwFlags : COM_HOOKS_END);

 CHServerName     = 'ComHooks.dll';
 CHRegisterName   = 'RegisterComHookChain';
 type TCHRegister = function(lpComHookChain : Pointer) : Integer; stdcall;

implementation
end.