//#define UNICODE
#define _OLE32_  //for InlineIsEqualGUID
#include <windows.h>
#include <objbase.h>
#define CH_STATIC_LINKING
#include <ComHooks.h>

#ifdef _MSC_VER
  #pragma comment(lib,"USER32")
  #pragma comment(lib,"ADVAPI32")
  #pragma comment(lib,"OLE32")
  #pragma comment(lib,"SHELL32")
#endif

#ifdef CH_STATIC_LINKING
 #ifdef _MSC_VER
  #pragma comment(linker,"/DEF:VComLog.def")
 #endif
#endif

CRITICAL_SECTION g_MsgLock;
HWND g_hwndCL;

#ifdef __cplusplus
  #define RGUID (REFGUID)*
#else
  #define RGUID
#endif
//////////////////////////////////////////////////////////////////////////////

#define EIID(name) EXTERN_C const IID name
#define IIID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
        const IID name = { l, w1, w2, { b1, b2,  b3,  b4,  b5,  b6,  b7,  b8 } }

#define NUM_KNOWN_IIDS 1
  //#pragma comment(lib, "mmc")
  //EIID(IID_IResultDataPrivate);  too much data from mmc.lib to ComLog.dll, hence
  //defined internally
  //{1EBA2300-0854-11D0-8B03-00AA003CA9F6}
  IIID(IID_IResultDataPrivate,0x1EBA2300,0x0854,0x11D0,0x8B,0x03,0x00,0xAA,0x00,0x3C,0xA9,0xF6);

const LPCIID KnownIIDs[NUM_KNOWN_IIDS] = {
  &IID_IResultDataPrivate,
};

const LPCTSTR KnownIIDNames[NUM_KNOWN_IIDS] = {
  TEXT("IResultDataPrivate")
};

BOOL WINAPI SearchIIDName(LPCIID riid, LPTSTR lpIID) {
 int i; 
 for(i=0; i<NUM_KNOWN_IIDS; i++)
  if(InlineIsEqualGUID(RGUID riid, RGUID KnownIIDs[i]))
    return wsprintf(lpIID, TEXT("%s"), KnownIIDNames[i]);
 return FALSE;
}
//////////////////////////////////////////////////////////////////////////////

#define StrTempl TEXT("%lS")
#define InterfaceTempl TEXT("Interface\\%s")
#define CLSIDTempl TEXT("CLSID\\%s")
#define UNKNOWN TEXT("UNKNOWN")

VOID WINAPI GetIDs(LPCCLSID rclsid, LPCIID riid,
                   LPTSTR lpCLSID, LPTSTR lpCLSIDName,
                   LPTSTR lpIID, LPTSTR lpIIDName,
                   LPTSTR lpProgID) {
  LPWSTR strptr;
  TCHAR  CLSIDKey[256];
  TCHAR  IIDKey[256];
  TCHAR  TempString[256];
  LONG   numb;

  if(ProgIDFromCLSID(RGUID rclsid, &strptr) != S_OK)
    wsprintf(lpProgID, UNKNOWN);
  else {
    wsprintf(lpProgID, StrTempl, strptr);
    CoTaskMemFree(strptr);
  }

  numb = 128;
  wsprintf(lpIID, UNKNOWN);
  wsprintf(lpIIDName, UNKNOWN);
  if(StringFromIID(RGUID riid, &strptr) == S_OK) {
    wsprintf(lpIID, StrTempl, strptr);
    wsprintf(lpIIDName, StrTempl, strptr);
    CoTaskMemFree(strptr);
    wsprintf(IIDKey, InterfaceTempl, lpIID);
    if((RegQueryValue(HKEY_CLASSES_ROOT, IIDKey, TempString, &numb) == ERROR_SUCCESS) && (TempString[0] != '\0'))
      wsprintf(lpIIDName, TEXT("%s"), TempString);
    else
      if(!SearchIIDName(riid, lpIIDName))
        wsprintf(lpIIDName, TEXT("%s"), lpIID);
  }
  else
    SearchIIDName(riid, lpIIDName);

  numb = 128;
  wsprintf(lpCLSID, UNKNOWN);
  wsprintf(lpCLSIDName, UNKNOWN);
  if(StringFromCLSID(RGUID rclsid, &strptr) == S_OK) {
    wsprintf(lpCLSID, StrTempl, strptr);
    wsprintf(lpCLSIDName, StrTempl, strptr);
    CoTaskMemFree(strptr);
    wsprintf(CLSIDKey, CLSIDTempl, lpCLSID);
    if(RegQueryValue(HKEY_CLASSES_ROOT, CLSIDKey, TempString, &numb) == ERROR_SUCCESS)
      wsprintf(lpCLSIDName, TEXT("%s"), (TempString[0] != '\0') ? TempString : lpCLSID);
  }

} //GetIDs
//////////////////////////////////////////////////////////////////////////////

LPTSTR WINAPI GetSectionName(DWORD Address, LPTSTR ModuleName, LPDWORD ModuleBase) {
  MEMORY_BASIC_INFORMATION mbi;
  int i;
  LPTSTR ExeName = ModuleName;
  ModuleName[0] = '\0';
  if(VirtualQuery((LPCVOID)Address, &mbi, sizeof(mbi))) {
    *ModuleBase = (DWORD)mbi.AllocationBase;
    if(GetModuleFileName((HINSTANCE)mbi.AllocationBase, ModuleName, MAX_PATH)) {
      for(i=0; ModuleName[i] != '\0'; i++)
        if(ModuleName[i] == '\\')
          ExeName = &ModuleName[i+1];
    }
  }
  return ExeName;
}
//////////////////////////////////////////////////////////////////////////////

#define NUM_STANDARD_NAMES 3
const LPCTSTR StandardMethodNames[NUM_STANDARD_NAMES] = {
  TEXT("QueryInterface"),
  TEXT("AddRef"),
  TEXT("Release")
};

typedef struct _METHOD_NAME {
  LONG MethodNo;
  LPCTSTR MethodName;
} METHOD_NAME, *LPMETHOD_NAME;
typedef const METHOD_NAME *LPCMETHOD_NAME;

#define METHOD_NAMES_END -1
#define TERM_METHOD_NAME {METHOD_NAMES_END, NULL}

const METHOD_NAME IClassFactoryMethodNames[2+1] = {
  {3, TEXT("CreateInstance")},  
  {4, TEXT("LockServer")},
  TERM_METHOD_NAME
};

#define M_NUM_KNOWN_IIDS 1

const LPCMETHOD_NAME KnownMethodNames[M_NUM_KNOWN_IIDS] = {
  IClassFactoryMethodNames
};

const LPCIID mKnownIIDs[M_NUM_KNOWN_IIDS] = {
  &IID_IClassFactory
};

BOOL WINAPI SearchMethodName(LPCIID riid, LONG MethodNo, LPTSTR MethodName) {
 int i,j; 
 if(MethodNo < NUM_STANDARD_NAMES)
    return wsprintf(MethodName, TEXT("%s"), StandardMethodNames[MethodNo]);
 for(i=0; i<M_NUM_KNOWN_IIDS; i++)
  if(InlineIsEqualGUID(RGUID riid, RGUID mKnownIIDs[i]))
    for(j=0;KnownMethodNames[i][j].MethodNo != METHOD_NAMES_END; j++)
      if(KnownMethodNames[i][j].MethodNo == MethodNo)
        return wsprintf(MethodName, TEXT("%s"), KnownMethodNames[i][j].MethodName);
 return FALSE;
}
//////////////////////////////////////////////////////////////////////////////

#define MethodTempl TEXT("Method%04d")

VOID WINAPI GetMethodName(LPCIID riid, LONG MethodNo, LPTSTR MethodName) {
  if(!SearchMethodName(riid, MethodNo, MethodName))
    wsprintf(MethodName, MethodTempl, MethodNo);
}
//////////////////////////////////////////////////////////////////////////////

#define MainMethodInfoTempl TEXT("%.8X::%s::%s::%s\nStatus=%.8X\nCall returns to %.8X ~ [%s+%.8X]\nNumber of parameters=%d\nParameters in C order:")
#define ParamTempl TEXT("\n%.8X")

#define Result ((HRESULT)NumParameters_Result)
#define NumPar ((ULONG)(NumParameters_Result>>32))

VOID WINAPI SendInfo(LPCVOID This, LPCCLSID rclsid, LPCIID riid, LONG MethodNo, ULONGLONG NumParameters_Result, LPDWORD RetAddr) {
  DWORD  i;
  DWORD  ModuleBase;
  COPYDATASTRUCT cpdata;
  LPTSTR SectName;
  TCHAR  CLSIDid[80];
  TCHAR  IIDid[80];
  TCHAR  CLSIDname[128];
  TCHAR  IIDname[128];
  TCHAR  ProgID[128];
  TCHAR  MethodName[32];
  TCHAR  ModuleName[MAX_PATH];
  TCHAR  Info[MAX_PATH+32+128+128+128+80];

  cpdata.dwData = (DWORD)Info; // dwData !=0 .. don't print longline
  cpdata.lpData = Info;
  GetIDs(rclsid, riid, CLSIDid, CLSIDname, IIDid, IIDname, ProgID);
  GetMethodName(riid, MethodNo, MethodName);
  SectName = GetSectionName(RetAddr[0], ModuleName, &ModuleBase);
  if(cpdata.cbData = sizeof(TCHAR)*
                     (wsprintf(Info, MainMethodInfoTempl, This, CLSIDname,
                               IIDname, MethodName, Result,
                               RetAddr[0], SectName, RetAddr[0]-ModuleBase, NumPar)+1)) {
    EnterCriticalSection(&g_MsgLock);
    SendMessage(g_hwndCL, WM_COPYDATA, (WPARAM)g_hwndCL, (LPARAM)&cpdata);
    //method must have at least 1 parameter
    for(i=0; i<NumPar; i++) {
      cpdata.cbData = sizeof(TCHAR)*(wsprintf(Info, ParamTempl, RetAddr[i+4])+1);
      if(i == NumPar-1)
        cpdata.dwData = 0; // print longline
      SendMessage(g_hwndCL, WM_COPYDATA, (WPARAM)g_hwndCL, (LPARAM)&cpdata);
    }
    LeaveCriticalSection(&g_MsgLock);
  }
  return;
}
//////////////////////////////////////////////////////////////////////////////

#define MainInfoNewTempl TEXT("%s:\n CLSID=%s ~ <%s>\n   IID=%s ~ <%s>\nProgID={%s}\n  This=%.8X\nNumber of methods=%d\n")
#define MethodLocTempl TEXT("\n%-15s= %.8X ~ [%s+%.8X]")

VOID WINAPI SendInfoNew(LPCHINFO lpCHInfo, LPCTSTR InfoString, LPCCLSID rclsid, LPCIID riid, DWORD ***ppvObject) {
  LONG   i, NumMethods;
  DWORD  ModuleBase, RealMethodAddr;
  COPYDATASTRUCT cpdata;
  LPTSTR SectName;
  TCHAR  CLSIDid[80];
  TCHAR  IIDid[80];
  TCHAR  CLSIDname[128];
  TCHAR  IIDname[128];
  TCHAR  ProgID[128];
  TCHAR  MethodName[32];
  TCHAR  ModuleName[MAX_PATH];
  TCHAR  Info[MAX_PATH+32+128+128+128+80];

  cpdata.dwData = (DWORD)Info; // dwData !=0 .. don't print longline
  cpdata.lpData = Info;
  GetIDs(rclsid, riid, CLSIDid, CLSIDname, IIDid, IIDname, ProgID);
  NumMethods = lpCHInfo->CHApis->GetNumMethods(riid, *ppvObject);
  if(cpdata.cbData = sizeof(TCHAR)*(wsprintf(Info, MainInfoNewTempl, InfoString,
                                             CLSIDid, CLSIDname, IIDid, IIDname,
                                             ProgID, *ppvObject, NumMethods)+1) ) {
    EnterCriticalSection(&g_MsgLock);
    SendMessage(g_hwndCL, WM_COPYDATA, (WPARAM)g_hwndCL, (LPARAM)&cpdata);
    if(NumMethods != NUM_METHODS_UNKNOWN)
      for(i=0; i<NumMethods; i++) {
        GetMethodName(riid, i, MethodName);
        RealMethodAddr = (DWORD)lpCHInfo->CHApis->GetMethodAddr((LPVOID)((**ppvObject)[i]) );
        SectName = GetSectionName(RealMethodAddr, ModuleName, &ModuleBase);
        cpdata.cbData = sizeof(TCHAR)*(wsprintf(Info, MethodLocTempl, MethodName, RealMethodAddr, SectName, RealMethodAddr-ModuleBase)+1);
        if(i == NumMethods-1)
          cpdata.dwData = 0; // print longline
        SendMessage(g_hwndCL, WM_COPYDATA, (WPARAM)g_hwndCL, (LPARAM)&cpdata);
      }
    LeaveCriticalSection(&g_MsgLock);
  }
  return;
}
//////////////////////////////////////////////////////////////////////////////

VOID WINAPI SendInfoDispatch(DWORD MethodNo, LPVOID** Parameters) {
  #define GetTypeInfoCountOrdinal 3
  #define GetTypeInfoOrdinal      4
  #define GetIDsOfNamesOrdinal    5
  #define InvokeOrdinal           6 
  DWORD i;
  LPCTSTR DISP_;
  COPYDATASTRUCT cpdata;
  TCHAR  SubInfo[128];
  TCHAR  Info[1024];  

  Info[0] = '\0';
  switch(MethodNo) {
    case GetTypeInfoCountOrdinal :
      wsprintf(Info, TEXT("GetTypeCountInfo: %s"),
               (DWORD)Parameters[1][0] ? TEXT("Object provides type information.") :
                                         TEXT("Object doesn't provide type information.")
              );
      break;

/*  ToDo:
    case GetTypeInfoOrdinal :
      wsprintf(Info, TEXT("GetTypeInfo: %lS"), *(ITypeInfo **)Parameters[3]);
      break;
*/

    case GetIDsOfNamesOrdinal :
      wsprintf(Info, TEXT("GetIDsOfNames: Count of the names %u"),(DWORD)Parameters[3]);
      for(i=0; i<(DWORD)Parameters[3]; i++) {
        wsprintf(SubInfo, TEXT("\n%lS ~ %d"), (OLECHAR *)(Parameters[2][i]), (DISPID)(Parameters[5][i]));
        lstrcat(Info, SubInfo);
      } 
      break;

    case InvokeOrdinal :  
      switch((WORD)Parameters[4]) {
        case DISPATCH_METHOD         : DISP_ = TEXT("DISPATCH_METHOD");         break;
        case DISPATCH_PROPERTYGET    : DISP_ = TEXT("DISPATCH_PROPERTYGET");    break;
        case DISPATCH_PROPERTYPUT    : DISP_ = TEXT("DISPATCH_PROPERTYPUT");    break;
        case DISPATCH_PROPERTYPUTREF : DISP_ = TEXT("DISPATCH_PROPERTYPUTREF"); break;
        default                      : DISP_ = UNKNOWN;
      }
    // etc ....
      wsprintf(Info, TEXT("Invoke(%li,,,%s,...)"), (LONG)Parameters[1], DISP_);
      break;

    default:
      return;
  }
  if(cpdata.cbData = lstrlen(Info)) {
    cpdata.dwData = 0; // dwData = 0 .. print longline
    ++cpdata.cbData;
    cpdata.lpData = Info;
    EnterCriticalSection(&g_MsgLock);
    SendMessage(g_hwndCL, WM_COPYDATA, (WPARAM)g_hwndCL, (LPARAM)&cpdata);
    LeaveCriticalSection(&g_MsgLock);
  } 
}
//////////////////////////////////////////////////////////////////////////////

#ifdef _MSC_VER
  #include <DispEx.h>
#else
  IIID(IID_IDispatchEx, 0xa6ef9860, 0xc720, 0x11d0, 0x93, 0x37, 0x0, 0xa0, 0xc9, 0xd, 0xca, 0xa9);
#endif

__declspec(naked) VOID UniversalMethod(////////////CH PARAMETERS//////////////////
                                  DWORD Rsv1, DWORD Rsv2, LPCHINFO lpCHInfo,
                                  ////////////REAL PARAMETERS//////////////////
                                  LPVOID This, LPVOID Par2, LPVOID Par3, LPVOID Par4,
                                  LPVOID Par5, LPVOID Par6, LPVOID Par7, LPVOID Par8) {
///////////////locals
  ULONGLONG NumParameters_Result;
  LPDWORD RetAddr;
  static const g_NakedLocalsSize = sizeof(NumParameters_Result) + sizeof(RetAddr);

///////////////prologue
  _asm {
    push ebp
    mov  ebp, esp
    sub  esp, g_NakedLocalsSize
#ifndef _MSC_VER
    push ebx
    push esi
    push edi  
#endif
  }

///////////////executive part
  _asm  lea eax, [ebp+4]
  _asm  mov RetAddr, eax
  NumParameters_Result = lpCHInfo->CHApis->CallOldMethod(&This, NUM_PARAMETERS_UNKNOWN);
  SendInfo(This, &lpCHInfo->mCLSID, &lpCHInfo->mIID, lpCHInfo->MethodNo,
           NumParameters_Result, RetAddr);

  if((HRESULT)NumParameters_Result == S_OK)
    #define QueryInterfaceOrdinal    0
    #define CreateInstanceOrdinal    3
    #define CreateProxy              3
    #define CreateInstanceLicOrdinal 7
    if( ( lpCHInfo->MethodNo == QueryInterfaceOrdinal ) &&
        ( This != *(LPVOID *)Par3 )
      ) {
      //now Par2 = riid, Par3 = ppvObj
      SendInfoNew(lpCHInfo, TEXT("QueryInterface returned"), &lpCHInfo->mCLSID, (LPIID)Par2, (DWORD***)Par3);
      lpCHInfo->CHApis->HookMethods(&lpCHInfo->mCLSID, (LPIID)Par2, (LPVOID *)Par3, lpCHInfo->ComHookChain, ALL_COM_HOOKS);
    }
    else
      if( (lpCHInfo->MethodNo == CreateInstanceOrdinal) &&
          (lpCHInfo->CHApis->CompareIDs(&IID_IClassFactory, &lpCHInfo->mIID) ||
           lpCHInfo->CHApis->CompareIDs(&IID_IClassFactory2, &lpCHInfo->mIID)) ) {
        //now Par2 = pUnkOuter, Par3 = riid, Par4 = ppvObj
        SendInfoNew(lpCHInfo, TEXT("IClassFactory?::CreateInstance created"), &lpCHInfo->mCLSID, (LPIID)Par3, (DWORD***)Par4);
        lpCHInfo->CHApis->HookMethods(&lpCHInfo->mCLSID, (LPIID)Par3, (LPVOID *)Par4, lpCHInfo->ComHookChain, ALL_COM_HOOKS);
      }
      else
        if( (lpCHInfo->MethodNo == CreateInstanceLicOrdinal) &&
             lpCHInfo->CHApis->CompareIDs(&IID_IClassFactory2, &lpCHInfo->mIID) ) {
          //now Par2 = pUnkOuter, Par3 = pUnkReserved, Par4 = riid, Par5 = bstrKey, Par6 = ppvObj
          SendInfoNew(lpCHInfo, TEXT("IClassFactory2::CreateInstanceLic created"), &lpCHInfo->mCLSID, (LPIID)Par4, (DWORD***)Par6);
          lpCHInfo->CHApis->HookMethods(&lpCHInfo->mCLSID, (LPIID)Par4, (LPVOID *)Par6, lpCHInfo->ComHookChain, ALL_COM_HOOKS);
        }
        else
          if( (lpCHInfo->MethodNo == CreateProxy) &&
               lpCHInfo->CHApis->CompareIDs(&IID_IPSFactoryBuffer, &lpCHInfo->mIID) ) {
            //now Par2 = pUnkOuter, Par3 = riid, Par4 = ppProxy, Par5 = ppv
            SendInfoNew(lpCHInfo, TEXT("IPSFactoryBuffer::CreateProxy created"), &lpCHInfo->mCLSID, (LPIID)Par3, (DWORD***)Par5);
            lpCHInfo->CHApis->HookMethods(&lpCHInfo->mCLSID, (LPIID)Par3, (LPVOID *)Par5, lpCHInfo->ComHookChain, ALL_COM_HOOKS);
          }
          else
            if(lpCHInfo->CHApis->CompareIDs(&IID_IDispatch, &lpCHInfo->mIID) ||
               lpCHInfo->CHApis->CompareIDs(&IID_IDispatchEx, &lpCHInfo->mIID))
              SendInfoDispatch(lpCHInfo->MethodNo, (LPVOID**)&This);
   
/////////////epilogue
  _asm {
#ifndef _MSC_VER
    pop edi
    pop esi
    pop ebx
#endif
    mov edx, dword ptr NumParameters_Result+4
    mov eax, dword ptr NumParameters_Result
    leave
    add edx, 3  //// eat CH parameters too!!!
    pop ecx
    lea esp, [esp+edx*4]
    jmp ecx
  }
}
//////////////////////////////////////////////////////////////////////////////
  
#define NUM_METHOD_HOOKS 1
const METHOD_HOOK MethodHooks[NUM_METHOD_HOOKS+1] = {
  {ALL_METHODS, UniversalMethod},
  TERM_METHOD_HOOK
};

#define NUM_COM_HOOKS 1
const COM_HOOK ComHookChain[NUM_COM_HOOKS+1] = {
  {CLASS_INTERFACE,ALL_CLASSES,NO_CLASSES,ALL_INTERFACES,NO_INTERFACES,NUM_METHODS_UNKNOWN,MethodHooks,NULL},
  TERM_COM_HOOK
};
//////////////////////////////////////////////////////////////////////////////

#define ComLogWindowTempl TEXT("COMLOG%.2d")

#ifdef __TURBOC__
  BOOL APIENTRY DllEntryPoint(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
#else
  #ifdef _MSC_VER
    BOOL APIENTRY DllMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
  #else
    BOOL APIENTRY LibMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
  #endif
#endif
{ 

#ifndef CH_STATIC_LINKING
  HANDLE CHLib;
  TCHRegister RegisterComHookChain;
#endif

  TCHAR ComLogWindow[12];
  HWND hwnd = NULL;
  int i = 0;

  if(ul_reason_for_call == DLL_PROCESS_ATTACH) {
    do {
      wsprintf(ComLogWindow, ComLogWindowTempl, i++);
      g_hwndCL = hwnd;
    } while(hwnd = FindWindow(ComLogWindow, NULL));

    if(g_hwndCL) {
      InitializeCriticalSection(&g_MsgLock);

#ifndef CH_STATIC_LINKING
      if(CHLib = GetModuleHandle(CHServerName))
        if((LPCVOID)RegisterComHookChain = GetProcAddress(CHLib, CHRegisterName))
#endif
          return RegisterComHookChain(ComHookChain);
    }
  }
  else
    if(ul_reason_for_call == DLL_PROCESS_DETACH)
      SendMessage(g_hwndCL, WM_DESTROY, 0, 0);
  return FALSE;
}