//#define UNICODE
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <windows.h>
#define AH_STATIC_LINKING
#include <ApiHooks.h>
#define PW_STATIC_LINKING
#include <ProcessWorks.h>
#define CH_STATIC_LINKING
#include <ComHooks.h>

#ifdef _MSC_VER
  #pragma comment(lib,"USER32")
  #pragma comment(lib,"ADVAPI32")
  #pragma comment(lib,"OLE32")
  #pragma comment(lib,"SHELL32")
#endif

#define Usage TEXT("ComLog 1.0 logs COM events in given process.\nUsage: ComLog -<n|o>[q] <Process|PID> [Parameters]\n q = log to file only\n-n = create new Process with Parameters\n-o = work with running Process or PID\nPID = process identifier: hexa/decimal number with 0x/0d prefix\n")
#define DllSufix TEXT(".dll")
#define ComLogWindowTempl TEXT("COMLOG%.2d")
#define LoggingTitle TEXT("%s: %s")
#define LongLine TEXT("\n-------------------------------------------------------------------------------\n")

#ifdef UNICODE
  #define PrintToFile fwprintf
  #define FileOpen _wfopen
  #define PrintToScreen wprintf
  #define strcmpin _wcsnicmp
  #define strscan swscanf
  #define Start wmain
#else
  #define PrintToFile fprintf
  #define FileOpen fopen
  #define PrintToScreen printf 
  #define strcmpin strnicmp
  #define strscan sscanf
  #define Start main
#endif

#ifndef _MSC_VER
 #define getch getchar
#endif

FILE *g_hLog;
BOOL Silent;
/////////////////////////////////////////////////////////

LRESULT CALLBACK ComLogWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
  if(uMsg == WM_DESTROY)
    PostQuitMessage(0);
  else
    if(uMsg == WM_COPYDATA) {
      PrintToFile(g_hLog, TEXT("%s"), ((COPYDATASTRUCT*)lParam)->lpData);
      if(!((COPYDATASTRUCT*)lParam)->dwData)
        PrintToFile(g_hLog, LongLine);
      if(!Silent) {
        PrintToScreen(TEXT("%s"), ((COPYDATASTRUCT*)lParam)->lpData);
        if(!((COPYDATASTRUCT*)lParam)->dwData)
          PrintToScreen(LongLine);
      } 
    }
  return DefWindowProc(hwnd, uMsg, wParam, lParam);
}    
/////////////////////////////////////////////////////////

WNDCLASS ComLogClass =
{CS_GLOBALCLASS, ComLogWndProc, 0, 0, NULL, NULL, NULL,
 NULL, NULL, NULL};
/////////////////////////////////////////////////////////

  typedef union {
    COORD coord;
    WORD  wsize[2];
  } LCC32_COORD;

int Start(int argc, TCHAR** argv) {
  PROCESS_INFORMATION pri;
  static STARTUPINFO sti = {sizeof(sti)};
  TCHAR ProcessName[MAX_PATH];
  TCHAR ComLogDllName[MAX_PATH];
  TCHAR LogFile[MAX_PATH];
  TCHAR Logging[sizeof(LoggingTitle)/sizeof(TCHAR)+sizeof(TCHAR)*(MAX_PATH+80)];
  int nchars, nCmdShow, i=0;
  BOOL IsNew;
  HWND hwndCon;
  MSG msg;
  TCHAR ComLogWindow[12];
  HANDLE StdOut;
  LCC32_COORD cbsize = {{80, 0x910}};

  FreeConsole(); 
  AllocConsole();
  StdOut = GetStdHandle(STD_OUTPUT_HANDLE);
  SetConsoleTitle(TEXT("       ComLog version 1.0 by EliCZ       http:////EliCZ.com       ComHooks@EliCZ.com"));
  if(argc < 3) 
    PrintToScreen(Usage);
  else {
    nchars = GetModuleFileName(NULL, ComLogDllName, sizeof(ComLogDllName));
    lstrcpy(ComLogDllName+nchars-(sizeof(DllSufix)/sizeof(TCHAR)-1), DllSufix);
    ExpandEnvironmentStrings(argv[2], ProcessName, sizeof(ProcessName));
    do {   
      wsprintf(ComLogWindow, ComLogWindowTempl, i++);
    } while(FindWindow(ComLogWindow, NULL)); 
 
    ComLogClass.hInstance = GetModuleHandle(NULL);
    ComLogClass.lpszClassName = ComLogWindow;
    if(RegisterClass(&ComLogClass))
      if(CreateWindow(ComLogWindow, NULL,
                      0, 0, 0, 0, 0,
                      NULL, NULL, ComLogClass.hInstance, NULL)) {
        if(IsNew = !strcmpin(argv[1], TEXT("-n"), 2)) {
          for(i=3; i<argc; i++) {
              lstrcat(ProcessName, TEXT(" \""));
              lstrcat(ProcessName, argv[i]);
              lstrcat(ProcessName, TEXT("\""));
          }
          if(!CreateProcess(NULL, ProcessName, NULL, NULL, FALSE,
                            CREATE_NEW_CONSOLE | CREATE_SUSPENDED,
                            NULL, NULL, &sti, &pri)) {
            PrintToScreen(TEXT("\nCOMLOG: Can't create Target process!"));
            return getch();
          }
        }
        else
          if(!(IsNew = strcmpin(argv[1], TEXT("-o"), 2)))
            if(!strcmpin(TEXT("0x"), ProcessName, 2))
              strscan(ProcessName, TEXT("%x"), &pri.dwProcessId);
            else
              if(!strcmpin(TEXT("0d"), ProcessName, 2))  
                strscan(ProcessName+2, TEXT("%u"), &pri.dwProcessId);
              else
                if(((LONG)(pri.dwProcessId = (DWORD)ProcessName2PID(ProcessName)) == PIDERROR) ||
                   ((LONG)pri.dwProcessId == MEMERROR)) {
                  PrintToScreen(TEXT("\nCOMLOG: Can't find %s!"), argv[2]);
                  return getch();
                }
 
#ifdef CH_STATIC_LINKING  //ComLog.dll was linked with ComHooks. ComHooks is Hooks_DLL.
                          //Resulting .dll must be Hooks_DLL too. EAH must be called.
        #define CHServerName ComLogDllName
        if(EstablishApiHooks(CHServerName, pri.dwProcessId, 30000))
#else                     //ComLog.dll is linked dynamically. LAC is enough. But ComHooks.dll
                          //must be preloaded via EAH.
  #ifdef __UNKNOWNC__
        #define CHServerName ComLogDllName
        if(EstablishApiHooks(CHServerName, pri.dwProcessId, 30000))
  #else
        EstablishApiHooks(CHServerName, pri.dwProcessId, 30000);
        if(LoadAndCall(ComLogDllName, pri.dwProcessId, 30000, 1, TEXT("RegCHChain")) <= ErrorTimeOut)
  #endif
#endif
        {
          if(IsNew) {
            CloseHandle(pri.hThread);
            TerminateProcess(pri.hProcess, 0xE1C2);
            CloseHandle(pri.hProcess);
          }
          PrintToScreen(TEXT("\nCOMLOG: Can't establish COM hooks!"));
          return getch();
        }
        else {
          i=0;
          wsprintf(LogFile, TEXT("ComLog%.2d.txt"), i++);
          while( (g_hLog = FileOpen(LogFile, TEXT("rb"))) && (i<100) ) {
            fclose(g_hLog);
            wsprintf(LogFile, TEXT("ComLog%.2d.txt"), i++);
          }
          if(i>=100) {
            PrintToScreen(TEXT("\nCOMLOG: Can't establish COM hooks!"));
            return getch();
          }
          g_hLog = FileOpen(LogFile, TEXT("wb+"));
          wsprintf(Logging, LoggingTitle, ComLogWindow, ProcessName);
          SetConsoleTitle(Logging);
          //the next "for" is for Win9x's FindWindow
          for(i=0; (!(hwndCon = FindWindow(NULL, Logging)))&&(i<20000); i++);
          nCmdShow = ((int)GetVersion()<0) ? SW_RESTORE : SW_SHOWMAXIMIZED;
          if(Silent = ((argv[1][2] | ' ') == 'q'))
            ShowWindow(hwndCon, SW_MINIMIZE);
          else {
            while(!SetConsoleScreenBufferSize(StdOut, cbsize.coord))
              cbsize.wsize[1] -= 0x10;
            ShowWindow(hwndCon, nCmdShow);
            SetForegroundWindow(hwndCon);
          }
          if(IsNew) {
            ResumeThread(pri.hThread);
            CloseHandle(pri.hThread);
            CloseHandle(pri.hProcess);
          }
          while((i = GetMessage(&msg, NULL, 0, 0)) && (i != -1))
            DispatchMessage(&msg);
          fclose(g_hLog);
          ShowWindow(hwndCon, nCmdShow);
          SetForegroundWindow(hwndCon);
          PrintToScreen(TEXT("\nCOMLOG: Process terminated. Session stored to %s.\n\7"), LogFile);
        } 
      } //CreateWindow
  }
  return getch();        
}