//#define UNICODE
#include <windows.h>
#include <objbase.h>
#include <ShlObj.h>
#include <ShlGuid.h>
//#define CH_STATIC_LINKING
#include <ComHooks.h>

#ifdef _MSC_VER
  #pragma comment(lib,"USER32")
  #pragma comment(lib,"ADVAPI32")
  #pragma comment(lib,"OLE32")
  #pragma comment(lib,"SHELL32")
#endif

#ifdef CH_STATIC_LINKING
 #ifdef _MSC_VER
  #pragma comment(linker,"/DEF:VTest0.def")
 #endif
#endif

// for CONST_INTERFACE:---------------------------------
IMalloc *pvCoGetMalloc = NULL, *pvSHGetMalloc = NULL;
HRESULT CoGetMallocResult, SHGetMallocResult;

HRESULT WINAPI GetSHGetMalloc(IMalloc **ppv) {
   *ppv = pvSHGetMalloc;
   return SHGetMallocResult;
}

HRESULT WINAPI GetCoGetMalloc(IMalloc **ppv) {
   *ppv = pvCoGetMalloc;
   return CoGetMallocResult;
}

// NewMethods:---------------------------------
HRESULT WINAPI NewQueryInterface(DWORD ReqPar1, DWORD ReqPar2, LPCHINFO lpCHInfo,
               LPVOID This, LPCIID riid, LPVOID *ppvObj) {
  HRESULT Result;
  Beep(100, 100); 
  Result = lpCHInfo->CHApis->CallOldMethod(&This, 3);
  if((Result == S_OK) && (This != *ppvObj))
    lpCHInfo->CHApis->HookMethods(&lpCHInfo->mCLSID, riid, ppvObj, lpCHInfo->ComHookChain, ALL_COM_HOOKS);
  return Result;
}

HRESULT WINAPI NewCoGetMallocRealloc(DWORD ReqPar1, DWORD ReqPar2, LPCHINFO lpCHInfo,
               LPVOID This, LPVOID pv, ULONG cb) {
  Beep(200, 100); 
  return lpCHInfo->CHApis->CallOldMethod(&This, 3);
}

HRESULT WINAPI NewSHGetMallocRealloc(DWORD ReqPar1, DWORD ReqPar2, LPCHINFO lpCHInfo,
               LPVOID This, LPVOID pv, ULONG cb) {
  Beep(300, 100); 
  return lpCHInfo->CHApis->CallOldMethod(&This, 3);
}

HRESULT WINAPI NewClassFactoryCreateInstance(DWORD ReqPar1, DWORD ReqPar2, LPCHINFO lpCHInfo,
               LPVOID This, LPUNKNOWN pUnkOuter, LPCIID riid, LPVOID *ppvObj) {
  HRESULT Result;
  Beep(400, 100); 
  Result = lpCHInfo->CHApis->CallOldMethod(&This, 4);
  if(Result == S_OK)
    lpCHInfo->CHApis->HookMethods(&lpCHInfo->mCLSID, riid, ppvObj, lpCHInfo->ComHookChain, ALL_COM_HOOKS);
  return Result;
}

HRESULT WINAPI NewDispatchInvoke(DWORD ReqPar1, DWORD ReqPar2, LPCHINFO lpCHInfo,
               LPVOID This, DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags,
               DISPPARAMS *pdispparams, VARIANT *pvarResult, EXCEPINFO *pexcepinfo,
               UINT *puArgErr) {
  Beep(500, 100); 
  return lpCHInfo->CHApis->CallOldMethod(&This, 9);
}

HRESULT WINAPI NewShellLinkASetDescription(DWORD ReqPar1, DWORD ReqPar2, LPCHINFO lpCHInfo,
               LPVOID This, LPCSTR pszName) {
  Beep(600, 100); 
  return lpCHInfo->CHApis->CallOldMethod(&This, 2);
}

HRESULT WINAPI NewShellLinkASetPath(DWORD ReqPar1, DWORD ReqPar2, LPCHINFO lpCHInfo,
               LPVOID This, LPCSTR pszFile) {
  Beep(700, 100); 
  return lpCHInfo->CHApis->CallOldMethod(&This, 2);
}

// Method Hooks:---------------------------------
const METHOD_HOOK IUnknownMH[2] = {
  {0, NewQueryInterface},
  TERM_METHOD_HOOK
};

const METHOD_HOOK SHGetMallocMH[2] = {
  {4, NewSHGetMallocRealloc},
  TERM_METHOD_HOOK  
};

const METHOD_HOOK CoGetMallocMH[2] = {
  {4, NewCoGetMallocRealloc},
  TERM_METHOD_HOOK  
};

const METHOD_HOOK IClassFactoryMH[2] = {
  {3, NewClassFactoryCreateInstance},
  TERM_METHOD_HOOK  
};

const METHOD_HOOK IDispatchMH[2] = {
  {6, NewDispatchInvoke},
  TERM_METHOD_HOOK  
};

const METHOD_HOOK IShellLinkAMH[3] = {
  {7, NewShellLinkASetDescription},
  {20,NewShellLinkASetPath},
  TERM_METHOD_HOOK
};

// CLSID defs:---------------------------------
const CLSID CLSID_HTMLDoc40 = {0x025336920, 0x03F9, 0x11CF, 0x08F,0x0D0, 0x000,0x0AA,0x000,0x068,0x06F,0x013};

// CLSIDs:---------------------------------
const LPCCLSID CLSIDHTMLDoc40[2] = {
  &CLSID_HTMLDoc40,
  TERM_CLSID
};

// IID defs:---------------------------------
//const IID IID_IShellLinkA = {0x0000214EE, 0x0000, 0x0000, 0x0C0,0x000, 0x000,0x000,0x000,0x000,0x000,0x046};

// IIDs:---------------------------------
const LPCIID IClassFactoryID[2] = {
  &IID_IClassFactory,
  TERM_IID
};

const LPCIID IDispatchID[2] = {
  &IID_IDispatch,
  TERM_IID
};

const LPCIID IShellLinkAID[2] = {
  &IID_IShellLinkA,
  TERM_IID
};

// COM_HOOKs:---------------------------------
const COM_HOOK Test0[6+1] = {
  {CONST_INTERFACE, GetSHGetMalloc, NO_CLASSES, ALL_INTERFACES,  NO_INTERFACES,  9, SHGetMallocMH,   NULL},
  {CONST_INTERFACE, GetCoGetMalloc, NO_CLASSES, ALL_INTERFACES,  NO_INTERFACES,  9, CoGetMallocMH,   NULL},
  {CLASS_INTERFACE, ALL_CLASSES,    NO_CLASSES, ALL_INTERFACES,  NO_INTERFACES,  3, IUnknownMH,      NULL},
  {CLASS_INTERFACE, ALL_CLASSES,    NO_CLASSES, IClassFactoryID, NO_INTERFACES,  5, IClassFactoryMH, NULL},
  {CLASS_INTERFACE, CLSIDHTMLDoc40, NO_CLASSES, IDispatchID,     NO_INTERFACES,  7, IDispatchMH,     NULL},
  {CLASS_INTERFACE, ALL_CLASSES,    NO_CLASSES, IShellLinkAID,   NO_INTERFACES, 21, IShellLinkAMH,   NULL},
  TERM_COM_HOOK
};


// Initialization:---------------------------------
#ifdef __TURBOC__
  BOOL APIENTRY DllEntryPoint(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
#else
  #ifdef _MSC_VER
    BOOL APIENTRY DllMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
  #else
    BOOL APIENTRY LibMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
  #endif
#endif
{ 

#ifndef CH_STATIC_LINKING
  HANDLE CHLib;
  TCHRegister RegisterComHookChain;
#endif

  if(ul_reason_for_call == DLL_PROCESS_ATTACH) {
    SHGetMallocResult = SHGetMalloc(&pvSHGetMalloc);
    CoGetMallocResult = CoGetMalloc(1, &pvCoGetMalloc);

#ifndef CH_STATIC_LINKING
      if(CHLib = GetModuleHandle(CHServerName))
        if(RegisterComHookChain = (LPVOID)GetProcAddress(CHLib, CHRegisterName))
#endif
          return RegisterComHookChain(Test0);
  }
  return FALSE;
}